package org.zipcoder.store;

import java.util.ArrayList;
import java.util.List;

public class ListMap implements MyMap {
    // instance field that is intialize to an ArrayList
    private List<Entry> entries = new ArrayList<>();
    private int size = 0;

//    public ListMap() {
//
//        this.entries = new ArrayList<>();
//    }

    @Override
    public int size() {
        return this.size;
    }

    @Override
    public boolean isEmptry() {
        if (this.getSize() == 0) {
            return true;
        }
        return false;
    }

    @Override
    public Cart get(User key) {
        // find the cart associate with the key
        for (Entry entry : entries) {
            if (entry.getKey().equals(key)) {
                return entry.getValue();
            }
        }
        return null;
    }

    @Override
    public void put(User key, Cart value) {
        if (get(key) != null) {
            for (Entry entry : entries) {
                if (entry.getKey().equals(key)) {
                    entry.setValue(value);
                }
            }
        } else {
            Entry newEntry = new Entry(key, value);
            entries.add(newEntry);
            setSize(size + 1);
        }
    }


    @Override
    public List<User> getKeys() {
        // get all the keys in the map
        List<User> userKeys = new ArrayList<>();
        for (Entry entry : this.entries) {
            userKeys.add(entry.getKey());
        }
        return userKeys;
    }

    @Override
    public List<Cart> getValues() {
        // get all the values in the map
        List<Cart> cartValues = new ArrayList<>();
        for (Entry entry : entries) {
            cartValues.add(entry.getValue());
        }
        return cartValues;
    }

    @Override
    public Cart remove(User key) {
        for (Entry entry : entries) {
            if (entry.getKey().equals(key)) {
                entries.remove(entry);
                return entry.getValue();
            }
        }
        return null;
    }

    public int getSize() {
        return size;
    }

    public void setSize(int size) {
        this.size = size;
    }
}
